/***************************************************************************
                          astar.cpp  -  description
                             -------------------
    begin                : Wed Nov 14 2001
    copyright            : (C) 2001 by Jos?Pablo Fern?dez
    email                : jpablo@localhost.localdomain
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qlist.h>

#include <iostream.h>

#include "astar.h"
#include "tree.h"
#include "astardata.h"


#include "milist.h"

AStar::AStar(){
	best = 0 ;
	min_h = 32000 ;
}

AStar::~AStar(){
}

/** No descriptions */
void AStar::init(AStarData *data){
	AStar::data = data ;
}

/** No descriptions */
Tree<AStarData> *AStar::resolve(int process) {
	
	MiList A ;	/* QList es una lista de punteros a datos */
	Tree<AStarData> *sucesores ;
	Tree<AStarData> *aux ;
	Tree<AStarData> *aux2 ;
	AStarData *N ;
	bool exito = false ;
	bool is_end = false ;
	AStarData *I ;

	int equals = 0 ;
	int tratados = 0 ;
	
	Tree<AStarData> *ins ;
	
	Tree<AStarData> *tree ;

	I=data ;
	/* DEBUG cout << "================" << endl ; */
	
	tree = new Tree<AStarData>(I) ;

	A.prepend(tree) ;
	/* DEBUG cout << "num elem: " << A.count() << endl ;	*/
	
	while (!A.isEmpty() && !exito && !is_end) {
		aux = A.take(0) ;

		N = aux->data();

		tratados++ ;
				
		if (N->isGoal()) {
			exito = true ;
			/* DEBUG cout << "exito" << endl ; */
			/* return (aux) ; */
		}

		if (N->get_h() < min_h) {
			min_h = N->get_h() ;
			best = aux ;
		}

		if (tratados == process) {
			is_end = true ;
		}
			
		
		sucesores = N->sucesors() ;
		aux->insertSons(sucesores) ;
		
		for (ins = sucesores; ins != null; ins = ins->brother() ) {
		/*	for (aux2 = A.first(); aux2 != null; aux = A.next()) {
				if (
					! ( (*(aux2->data())).isEqual(*(ins->data()) ) { */
					/* A.prepend(ins) ; */
					A.inSort(ins) ;
		/*		} else {
					equals++ ;
				}           */
			}
		/* DEBUG
		cout << "Num elem: " << A.count() << endl ;
		cout << "Tratados: " << tratados << endl ;
		cout << "Iguales: " << equals << endl ;		

		cout << "-----------------------------------------------" << endl ;
		*/
	}

	/* if (is_end) { BUG Fallaba si no podia generar mas hijos antes de prcess */
	if (process != 0) {
		return (best) ;
	}

	if (exito) {
		return (aux ) ;
	} else {
		return null ;
	}

	
}

